.TH STEMGINE 1 "2009-04-17" "simple template engine 1.9.0"


.SH NAME

stemgine  \- simple template engine


.SH DESCRIPTION

.B stemgine
is a very simple, flexible and powerful template engine. It simply
evaluates template files as shell code, thus replacing shell variables with the
ones present in the environment.


.SH SECURITY

Since the content of the templates is written using eval and echo, you
.B have to
make sure that no one can inject code into your template files. However, this
should be the default configuration of umask.


.SH BACKEND

.TP
.B Template file
Regular text file. Contents are evaluated using echo so one can use all those
nice shell features like variables, backticks (and hence all your cli programs)
and so on.

Example:

// $PROJECT-$VERSION (C) $YEARS $AUTHORS

.TP
.B TEMPLATE_DIR
Contains template files. Each file is in a subdirectory named after the file
extension.

Example:

.nf
template
|-- cxx
|   |-- isc.cxx
|   `-- wtfpl.cxx
`-- sh
    `-- wtfpl.sh

.TP
.B ~/.stemginerc
Configuration file, must contain path to template directory in sh syntax.

Example:

TEMPLATE_DIR="$HOME/templates"


.SH FRONTEND / SEE ALSO

.TP
.BR stemgine::list (1)
lists all templates

.TP
.BR stemgine::eval (1)
evaluates a template

.TP
.BR stemgine::scotem (1)
interface for simple code templates

.TP
.BR stemgine::vecotem (1)
interface for verbose code templats


.SH COMMAND COMPLETION

.TP
.B ZSH
.nf
function templates { reply=(`stemgine::list`); }
compctl -K templates stemgine::eval stemgine::vecotem stemgine::scotem


.SH WEBSITE

http://programmers.at/work/on/app-text/stemgine


.SH REPOSITORY

git://repo.or.cz/stemgine.git


.SH AUTHORS

Andreas Waidler <arandes@programmers.at>
